﻿ReagentHelper2 = LibStub("AceAddon-3.0"):NewAddon("ReagentHelper2", "AceEvent-3.0", "AceConsole-3.0")
local TipHooker = LibStub:GetLibrary("LibTipHooker-1.1");
local AceConfig = LibStub("AceConfigDialog-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("ReagentHelper2");
local BabbleClass = LibStub("LibBabble-Class-3.0"):GetLookupTable();
local BabbleInventory = LibStub("LibBabble-Inventory-3.0"):GetLookupTable();

local ToolTipList = {};
local ToolTipString = "";
local TooltTipStringCount = 0;

function ReagentHelper2:OnInitialize()
	ReagentHelper2:RegisterChatCommand("rh", "ChatCommand")
	ReagentHelper2:RegisterChatCommand("rh2", "ChatCommand")
	ReagentHelper2:RegisterChatCommand("reagenthelper", "ChatCommand")
	ReagentHelper2:RegisterChatCommand("reagenthelper2", "ChatCommand")
	
	ReagentHelper2.db = LibStub("AceDB-3.0"):New("ReagentHelper2DB", ReagentHelper2.defaults, "profile");
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ReagentHelper2", ReagentHelper2.options)
	AceConfig:AddToBlizOptions("ReagentHelper2", "Reagent Helper 2");
end

function ReagentHelper2:OnEnable()
	TipHooker:Hook(ReagentHelper2.ModifyItemTooltip, "item");
end

function ReagentHelper2:ChatCommand()
	InterfaceOptionsFrame_OpenToCategory("Reagent Helper 2");
end

function ReagentHelper2.ModifyItemTooltip(tooltip, name, link)
	if (ReagentHelper2.db.profile.Disabled == false) then
		ToolTipList = table.wipe(ToolTipList);
		ToolTipString = "";
		TooltTipStringCount = 1;
		local itemName, itemLink = tooltip:GetItem()
		if (itemName) then
			ReagentHelper2:SearchReagentDB(itemName);
			table.sort(ToolTipList);
			if (ReagentHelper2.db.profile.ToolTipCommma == false) then
				for k, v in pairs(ToolTipList) do	
					tooltip:AddLine(v);
				end
			else
				for k, v in pairs(ToolTipList) do
					if (ToolTipString == "") or (ToolTipString == nil) then
						ToolTipString = v;
						TooltTipStringCount = TooltTipStringCount + 1;
					else
						if (TooltTipStringCount == 4 or TooltTipStringCount == 7 or TooltTipStringCount == 10) then
							tooltip:AddLine(ToolTipString);
							ToolTipString = "";
							ToolTipString = v;
							TooltTipStringCount = TooltTipStringCount + 1;
						else
							ToolTipString = ToolTipString..", "..v;
							TooltTipStringCount = TooltTipStringCount + 1;
						end				
					end
				end
				tooltip:AddLine(ToolTipString);
			end		
			
			ToolTipString = "";
			TooltTipStringCount = 0;
			ToolTipList = table.wipe(ToolTipList);
			tooltip:Show();
		end
	end
end

function ReagentHelper2:SearchReagentDB(ItemName)
	if (ReagentHelper2.db.profile.Disabled == false) then
		if (ReagentHelper2.db.profile.DisableProfession == false) then
			for k, v in pairs(ReagentHelper2.Alchemy) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleInventory["Alchemy"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Blacksmithing) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleInventory["Blacksmithing"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Cooking) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleInventory["Cooking"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Enchanting) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleInventory["Enchanting"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Engineering) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleInventory["Engineering"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.FirstAid) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleInventory["First Aid"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Inscription) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, L["Inscription"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Jewelcrafting) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleInventory["Jewelcrafting"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Leatherworking) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleInventory["Leatherworking"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Mining) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, L["Mining"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Tailoring) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleInventory["Tailoring"]);
					break;
				end
			end
		end
		
		if (ReagentHelper2.db.profile.DisableClass == false) then
			for k, v in pairs(ReagentHelper2.Mage) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleClass["Mage"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Priest) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleClass["Priest"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Warlock) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleClass["Warlock"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.DeathKnight) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleClass["Deathknight"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Druid) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleClass["Druid"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Shaman) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleClass["Shaman"]);
					break;
				end
			end
			for k, v in pairs(ReagentHelper2.Paladin) do
				if (ItemName == GetItemInfo(v)) then
					table.insert(ToolTipList, BabbleClass["Paladin"]);
					break;
				end
			end
		end
	end
end